#ifndef _ACTION_ID_H_
#define _ACTION_ID_H_

// colors
/*
Button:
    Border  : 2 colors
    Face    : 1 color
    Textfore: 1 color
    Textback: 1 color
    OutLine : 1 color

    Total   : 6 colors
*/

//
// The following are ids for each class ( return by identify )
// The order of from small to large is important.  Higher number means
// they are derived from lower numbers or has no relationship to any of them.
//
#define OBJECT_ID   100       // very fundamental one
#define SCROBJ_ID   101       // based on object

#define BUTTON_ID   200     // based on scrobj
#define CHKBOX_ID   201     // based on button
#define STRBOX_ID   202     // based on button

#define MANAGER_ID  1000    // This one is indenpendent

#define VIEWMGR_ID  300     // based on manager and scrobj
#define DIALOG_ID   301     // based on viewmgr

#define NO_ACTION 0


// codes return by intercepters to the loop
#define UNREGME       -1
#define UNREGMEnSTOP  -2
#define STOPNOW       -100

// Action ids.  'actId' filed of a message

// id 1 to id 2000 are reserved
#define CANCEL_CLICK    1
#define MOUSE_ON        2
#define MOUSE_OFF       3
#define KEY_DOWN        4
#define REDRAW          5

// Dialog actions
// #100 to #120 are reserved for dialogs
#define INSTALL_DIALOG   100
#define DESTROY_DIALOG   101
#define DIALOG_CONFIRM   102
#define DIALOG_CANCEL    103

// user defined actions:
#define userEDIT_CLEAR  2001 // must start with 2001
#define YESNO_YES       2002
#define YESNO_NO        2003

#endif
