#ifdef MOU_INTERFACE

#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#define LEFT_PRESSED   MOUSE_MIDDLEBUTTON
#define RIGHT_PRESSED  MOUSE_RIGHTBUTTON
#define LNR_PRESSED    0xf0
#define MIDDLE_PRESSED MOUSE_MIDDLEBUTTON
#define LNM_PRESSED    0xf0
#define RNM_PRESSED    0xf0
#define ALL_PRESSED    0xf0


//
// Mouse Functions expected to use in ObjMgr
//
#define m_MouseInit                     vga_setmousesupport(1)
#define m_MouseDeInit


//
// exported variables
//
extern int __mouse_x, __mouse_y, __mouse_button, __mouseFrozen;


// Redraw the mouse cursor and read x & y corrdinates
#define m_UpdateMouse

#define m_MouseX                        __mouse_x
#define m_MouseY						__mouse_y
#define m_ShowMouse                     __showMouse()
#define m_HideMouse                     __hideMouse()
#define m_MouseButtonStatus             __mouse_button
#define m_FreezeMouse                   __mouseFrozen = 1
#define m_DeFreezeMouse                 __mouseFrozen = 0

//
// Other functions not expected to use
//
// Set the cursor to cur <char far *> in color <int>
//
#define m_MouseSetCur(cur, color )       __mouseSetCur( cur )
#define m_MouseSetXY(x, y )              __mouseSetPos( x, y )

// Set a rect the pointer is limited in
//
#define m_MouseWindow(x1, y1, x2, y2 )      __mouseWindow( x1, y1, x2, y2 )

// Set the mouse cursor's color
//
#define m_MouseCurColor(color )

void __initMouseDriver();
void __showMouse();
void __hideMouse();
void __mouseSetCur( char* cur );
void __mouseWindow( int x1, int y1, int x2, int y2 );

#define CLICK  128 // 10000000
#define HOLD   16  // 00010000
#define DOUBLE 8   // 00001000
#define BUTTON 7   // 00000111

#define LCLICK (CLICK|LEFT_PRESSED)
#define MCLICK (CLICK|MIDDLE_PRESSED)
#define RCLICK (CLICK|RIGHT_PRESSED)
#define LHOLD  (HOLD|LEFT_PRESSED)
#define MHOLD  (HOLD|MIDDLE_PRESSED)
#define RHOLD  (HOLD|RIGHT_PRESSED)

#endif
