#include <dos.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include "macros.h"
#include "vidinter.h"
#include "xlibint1.h"
#include "pcx.h"
#include "fileio.h"
#include "debug.h"
#include "vidint1.h"
#include "colors.h"
#include <conio.h>
#include <string.h>

static int _LoadFixedFont (void );
int v_inter_c_break_handler (void ); //andadd
void HideRodent( void );              //andadd
void v_ResetColors( void );          //andadd

int DefColors[7];  // Colors 1-7(7 colors), system colors, 7 not yet use
// colors 7-15     // 9 colors for other uses
// colors 16-239   // 224 colors User colors
// colors 240-255  // 16 Special colors (pallete rotate, special effects.)
PCXAgent PCXFile;
static char far *fpFnt;

static RodentOldx, RodentOldy;    //andadd
int RodentHidden = 1;             //andadd
BYTE far SaveMouse[100];          //andadd
WORD VideoPage;                   //andadd


BYTE PCXAgent::buffer[PCX_RW_BUF_SIZE];

int _pascal_ PCXAgent::Open( char *name, int mode )
{
    Close();
    int FMode = O_BINARY|O_RDONLY;
    if ( mode != READ_PCX )
        FMode = O_BINARY|O_RDWR|O_CREAT;
    OpenMode = mode;
    opened = open( name, FMode, S_IREAD|S_IWRITE );
    return opened;
}

int _pascal_ PCXAgent::Close( void )
{
    if ( opened > -1 )
        if ( close(opened) == 0 )
            return 1;
    return 0;
}

int _pascal_ PCXAgent::Valid( void )
{
    return ( myHeader.Manufacturer == 10 &&
             myHeader.Version == 5 &&
             myHeader.Encode == 1 &&
             myHeader.BitsPerPix == 8 );
}

int _pascal_ PCXAgent::ReadHeader( void )
{
    if ( opened > -1 ) {
         return _read( opened, &myHeader, sizeof(myHeader) );
    }
    return 0;
}

int _pascal_ PCXAgent::Read256Pal( BYTE *data )
{
    //
    // Make sure it's version 5, data ptr is not null,
    // and the file is opened.
    //
    if ( myHeader.Version == 5 && data && opened > -1 ) {

        //
        // Make sure the file's size is big enough
        //
        if ( filelength( opened ) >= PCX_MINSIZE ) {

            //
            // Goto 769th byte from the end of file
            // and read the signature.
            //
            BYTE sig;
            lseek( opened, -769L, SEEK_END );
            _read( opened, &sig, sizeof(sig) );

            //
            // Make sure we have the right signature.
            //
            if ( sig == 12 ) {
                //
                // Read 768 bytes, which are a 256color palette
                //
                int r = _read( opened, data, 768 );

                //
                // Convert RGB value from 256 scale down to 64 scale
                //
                for( int i = 0; i < 768; i ++ ) {
                    //
                    // simply divide data[i] by 4 is the same.
                    //
                    data[i] = (data[i]*64)/256;
                }
                return r;

            } else
                return -3;
        } else
            return -2;
    }
    return -1;
}


void _pascal_ PCXAgent::RollLine( int count, int c )
{
    int x2;
    while( count > 0 ) {
        x2 = x+count-1;
        //
        // The line does not reach the end or run over to the next line
        //
        if ( x2 < myHeader.XMax ) {
            //
            // So just draw the line sectment and advance x
            //
            v_PutLine( x, y, x2, y, c );
            x = x2+1;
            break;
        } else {
            //
            // Draw to the end of the line and go to next line.
            //
            v_PutLine( x, y, myHeader.XMax, y, c );
            y ++;
            x = myHeader.XMin;

            //
            // Set count to the remaining number of pixels
            // for next line.
            //
            count = x2 - myHeader.XMax;
        }
    }

/*  Here is a slower but simpler version:

    for( int i = 0; i < count; i ++ ) {
        if ( x > myHeader.XMax ) {
            x = myHeader.XMin;
            y ++;
        }
        v_PutPixel( x, y, c );
        x ++;
    }
*/
}

char * _pascal_ PCXAgent::RollData( char *buf, int size )
{
    static int set = 0;
    int count, i = 0;
    char c;

    size += set;

    while( 1 ) {
        if ( i == size ) {
            set = 0;
            return buf;
        }
        c = buf[i++];
        if ( (c&0xc0) == 0xc0 ) {   // Is the Upper 2 bits 1's?
            //
            // Yes => decode it
            //
            if ( i == size ) {      // we have no more data.
                buf[0] = c;         // Save the code
                set = 1;            // Make sure we count the code later
                return( buf + 1 );  // Read into one byte off the buffer

            } else {
                count = 0x3f & c;   // do the decode
                c = buf[i++];

                if ( count > 1 )    // We need to roll out the line
                    RollLine( count, (int)c );

                else    // it's just a single pixel!

                    goto OH_MY_GOD_I_USED_GOTO;
            }
        } else {
OH_MY_GOD_I_USED_GOTO:
            v_PutPixel( x, y, c );  // This is a pixel!
            x ++;
        }
        //
        // Do we need to advance to next line?
        //
        if ( x > myHeader.XMax ) {
            x = myHeader.XMin;
            y ++;
        }
    }
}

int _pascal_ PCXAgent::Show( void )
{
    //
    // Include the extra space if the width is not even
    //
    myHeader.XMax = myHeader.BytesPerLine - 1;

    BYTE *buf = buffer;

    if ( opened > -1 && myHeader.Version == 5 ) {

        long len = filelength( opened );

        int ChunkSize = PCX_RW_BUF_SIZE, ReadSize;

        //
        // Set initial x and y
        //
        x = myHeader.XMin;
        y = myHeader.YMin;

        //
        // Is it a reasonable file?
        //
        if ( len >= PCX_MINSIZE ) {

            len -= PCX_MINSIZE;

            if ( len < PCX_RW_BUF_SIZE ) ChunkSize = (int)len;

            //
            // Goto begining of data
            //
            lseek( opened, 128L, SEEK_SET );

            while( len > 0 ) {
                ReadSize = _read( opened, buf, ChunkSize );

                if ( ReadSize > 0 ) {
                    if ( len < (long)ReadSize)
                        ReadSize = (int)len;
                    buf = RollData( buffer, ReadSize );
                } else
                    return ReadSize;

                len -= ReadSize;
            }
        } else
            return -2;
    }
    return -1;
}

int _pascal_ PCXAgent::SaveHeader()
{
    myHeader.Manufacturer = 10;
    myHeader.Version      = 5;
    myHeader.Encode       = 1;
    myHeader.BitsPerPix   = 8;
    myHeader.XMin         = 0;
    myHeader.YMin         = 0;
    myHeader.XMax         = v_XMax;
    myHeader.YMax         = v_YMax;
    myHeader.HRes         = 72;
    myHeader.VRes         = 72;
    memset(myHeader.ColorMap, 0, 48 );
    myHeader.NPlanes      = 1;
    myHeader.BytesPerLine = v_Width;
    myHeader.PalInfo      = 1;
    memset(myHeader.Filler, 0, 58 );
    return _write( opened, &myHeader, sizeof(myHeader));
}

int _pascal_ PCXAgent::PackLine( BYTE &count, BYTE &p )
{
    int c, ip, ip2;

    if ( y > myHeader.YMax ) return 3; // no more pixels

    c = 0;
    ip = ip2 = (BYTE)v_GetPixel( x, y );

    while( ip == ip2 ) {
        if ( c >= 63 )
            break;
        c ++;
        x ++;
        if ( x > myHeader.XMax ) {
            v_PutPixel( x-1, y, 0 );
            x = myHeader.XMin;
            y ++;
//            if( y > myHeader.YMax )
            break;
        } else
            v_PutPixel( x-1, y, 0 );
        ip2 = (BYTE)v_GetPixel( x, y );
    }
    p = (BYTE)ip;
    if ( (c > 1) || (ip&0xc0) == 0xc0 ) {
        count = (BYTE)(c|0xc0);
        return 1;
    }
    return 2;
}

int _pascal_ PCXAgent::PackBuf( BYTE *buf )
{
    int i = 0;
    BYTE c, p;
    while ( i < PCX_RW_BUF_SIZE-1 ) {
        switch( PackLine( c, p ) ) {
            case 1:
                buf[i++] = c;
                buf[i++] = p;
                break;  // count + data
            case 2:
                buf[i++] = p;
                break;  // data
            case 3:
                return i; // no more pixels
            default:
                break;
        }
    }
    return i;
}

int _pascal_ PCXAgent::Save( void )
{
    if( opened > -1 ) {
        int r, size;
        if( OpenMode != READ_PCX ) {
            chsize( opened, 0L );
            lseek( opened, 0L, SEEK_SET );
            if( (r = SaveHeader()) > 0 ) {
                x = y = 0;
                while( (size = PackBuf(buffer)) > 0 ) {
                    if( (r = _write( opened, buffer, size )) < 0 )
                        return r;
                }
                BYTE sig = 12;
                r = _write( opened, &sig, sizeof(sig));

                if ( r == 1 ) {
                    // v_GetPal( buffer );
                    x_get_pal_raw( buffer, 256, 0 );
                    for( r = 0; r < 768; r ++ ) {
                        buffer[r] = (buffer[r]*256)/64;
                    }
                    if ( (r = _write( opened, buffer, 768 )) == 768 )
                        return 0;
                }
                return r;
            } else
                return r;
        } else
            return -3;
    }
    return -2;
}

void _DeInitXLIB (void )   //andadd
{
	m_HideMouse;
    m_MouseDeInit;
    x_text_mode ();
	delete fpFnt;
	debug_msg( "Deinit XLIB completed.\n");
}


int _InitXLIB (void )
{
// formula to calculate extra width for the virtual screen using double buffer
// let A = 256000 - ( SplitScreenHight * PhysicalScreenHeight ) / 2
// then Extra width = A / ( PhysicalScreenHeight + DoubleBufferHeight )

    v_ResetColors();
	// Init XLIB Video mode
	x_text_mode ();
    x_set_mode ( MODE, 600 );
//    x_set_splitscreen( ScrnPhysicalHeight - v_SplitScrnHeight );
//    x_set_doublebuffer ( 200 );
//    x_hide_splitscreen();
	x_text_init ();
    
	// Load and set font
	if (_LoadFixedFont () )
		x_set_font (2 );               // use loaded font
	else
		x_set_font (0 );               // use VGA ROM 8x8 font

	// Set mouse
	m_MouseInit;

   ctrlbrk (v_inter_c_break_handler );
    #ifdef AUTO_DE_INIT
    atexit( _DeInitXLIB );
    #endif
    m_MouseCurColor ( 1 );

    VideoPage = VisiblePageOffs;

//    char far *pals = readfile( "data\\standard.pal");
    char far *pals = readfile( "standard.pal");
    v_PutPal( pals );
    x_hide_mouse();

	return 0;
}

int v_inter_c_break_handler (void ) //andadd
{
	return 1;
}

static int _LoadFixedFont (void )  //andadd
{
	fpFnt = readfile( strcat( FONTDIR, USERFONTNAME ) );
	// Register the font
	if ( fpFnt ) {
		x_register_userfont (fpFnt );
		return 1;
	} else
		return 0;
}

void HideRodent( void )              //andadd
{
    if ( !RodentHidden ) {
	RodentHidden = 1;
	v_Putbmp( RodentOldx, RodentOldy, SaveMouse );
    }
}

void v_ResetColors( void )
{
    int i, r = 0;
    char *p;
    FaceColor = 3;          // grey
    BtnUpColor = 1;         // white
    BtnLowColor = 4;        // dark grey
    HighLiteColor = 2;      // bright orange
    OutLineColor = 5;       // Red
    TextColor = 6;          // blue

    FILE *in = fopen( "sprdesg.ini", "r");
    if ( in == NULL ) return;
    char buf[30];
    while( in ) {
        p = fgets(buf, 30, in);
        if ( p == NULL ) return;
        if ( strncmpi(buf,"[SysColors]", 11) == 0 ) break;
    }
    i = 0;
    while( 1 ) {
        p = fgets(buf, 30, in);
        if ( p == NULL ) break;
        if( buf[0] == '~' ) {
            sscanf( buf+20, "%d", &r );
            DefColors[i++] = r;
            if ( i > 6 ) break;
        }
    }
    fclose( in );
}


//#ifdef TEST
//#ifndef TEST

main( int argc, char **argv )
{
    if ( argc < 2 ) return 1;

    if ( PCXFile.Open( argv[1]) < 0 ) {
        printf( "Open file: %s failed.\n", argv[1] );
        return 2;
    }
    PCXFile.ReadHeader();
    PCXHeader &Header = PCXFile.GiveHeader();

    printf( "Manufacturer: %u\n", Header.Manufacturer );
    printf( "Version     : %u\n", Header.Version );
    printf( "Encode      : %u\n", Header.Encode );
    printf( "BitsPerPix  : %u\n", Header.BitsPerPix );
    printf( "XMin        : %d\n", Header.XMin );
    printf( "YMin        : %d\n", Header.YMin );
    printf( "XMax        : %d\n", Header.XMax );
    printf( "YMax        : %d\n", Header.YMax );
    printf( "HRes        : %d\n", Header.HRes );
    printf( "VRes        : %d\n", Header.VRes );
    printf( "NPlanes     : %u\n", Header.NPlanes );
    printf( "BytesPerLine: %d\n", Header.BytesPerLine );
    printf( "PalInfo     : %d\n", Header.PalInfo );

    BYTE pal[768];
    int i;

    if ( !PCXFile.Valid()) {
        printf( "Not a PCX file or version/type not supported.\n");
        return 5;
    }

    if ( (i = PCXFile.Read256Pal( pal )) != 768 ) {
        printf( "Read palette error: %d\n", i );
        return 3;
    }

    printf( "Press Enter to continue." );
    getch();


    _InitVideo;

    v_PutPal( pal );
    PCXFile.Show();

    getch();
/*
    if ( (i = PCXFile.Open( "testout.pcx", WRITE_PCX )) < 0 ) {
        _RestoreVideo;
        printf( "Open testout.pcx error: %d\n", i );
        return 4;
    }

    i = PCXFile.Save();
*/
    _RestoreVideo;
/*
    if ( i != 0 ) {
        printf("Save: %d\n", i);
    }
*/

    return 0;
}

//#endif


