#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "debug.h"
#include "macros.h"
#include "errcode.h"
//andout #include "fileutil.h"
#include "buffer.h"
#include "vidinter.h"
#include "fileio.h"     //andadd

#ifdef __MSDOS__
#include <dos.h>
#include <dir.h>
#endif

#ifdef __LINUX__
#include <errno.h>
#endif

static char _FAR_ * ReadFile( char *name, int size, char _FAR_ *DataBuf )
{
    if ( name[0] == ']' ) {
        strcpy( buffer, WorkDir );
        strcat( buffer, name+1 );
        name = buffer;
    }
    char _FAR_ *data = readfile( name, size, DataBuf );
    return data;
}


static void _pascal_ LoadSysColors( FILE *in )
{
    // Find the system color section.

    char *bptr = FindString( '[', buffer, in, "SysColors]" );

    if ( bptr ) {

        // find the data file name
        bptr = FindString( '`', buffer+MAXPATH+1, in, 0 );
        if ( bptr ) {
            // Read the palette data file
            RawPalPtr = ReadFile( bptr, 768, RawPalData );
            if ( RawPalPtr != RawPalData ) {
                printf("Warning: RawPalPtr != RawPalData!\n");
            }
            if ( !RawPalPtr ) {
                printf("Error: read file %s failed.\n", bptr);
            }

            // Read SystemColors
            if ( FetchValues( '~', DefColors, in, 8, "[~SysColors]") )
                // Read into a different array.
                FetchValues( '~', RGBColors, in, 2, "[~SysColors]" );
        } else
            printf("Can't find palette file name.\n");
    } else
        printf( "Can't find section [SysColors]\n");
}


static void _pascal_ LoadSysFont( FILE *in )
{
    if ( FontDataPtr ) return;
    char *bptr = FindString( '[', buffer, in, "SysFont]");

    if ( bptr ) {
        bptr = FindString( '`', buffer+MAXPATH+1, in, 0 );
        if ( bptr ) {
            delete FontDataPtr;
            FontDataPtr = ReadFile( bptr, 0, 0 );
            if ( !FontDataPtr ) {
                printf("Error reading font file: %s\n", bptr );
            }
        } else {
            printf("Error! Can't find font file name.\n");
        }
    } else
        printf("Error! Can't find section [SysFont]\n");
}


void _pascal_ LoadINIFile( void )
{
    if ( WorkDir )
        strcpy( buffer, WorkDir );
    else
        buffer[0] = 0;

    strcat( buffer, "sprdesg.ini");
    FILE *in = fopen( buffer, "r");

    if ( in == NULL ) {
        printf( "Error opening ini file: %s\n", buffer );
        return;
    }

    LoadSysColors( in );
    rewind( in );
    LoadSysFont( in );
    fclose( in );
}
