#include "sprite.h"
#include "vidinter.h"
#include "timer.h"
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <DOS.h>
#include "debug.h"
#include "fileio.h"
//#include <xpal.h>
#include "xpal.h"
#include "xpbitmap.h"

#ifdef NormalTimer
#error Need fast timer turned on.
#endif

//
// bitmap member functions
//

// bitmap::CPut
//     Draw the bitmap to screen page ScrnOffs at pos x, y
void bitmap::CPut( WORD x, WORD y, WORD ScrnOffs )
{
    x_put_pbm( x, y, ScrnOffs, data );
}

// bitmap::CPutMasked
//     Same as bitmap::CPut except black colors are transparent
void bitmap::CPutMasked( WORD x, WORD y, WORD ScrnOffs )
{
    x_put_masked_pbm( x, y, ScrnOffs, data );
}


void bitmap::CGet( WORD x, WORD y, BYTE width, BYTE height,
              WORD ScrnOffs )
{
    WORD not_even = width % 4;
    if ( not_even )
        width += 4 - not_even;

    WORD datasize = height * width + 2;
    if ( data ) {
        if ( mysize != datasize) {
            delete data;
            data = new BYTE [datasize];
            mysize = datasize;
        }
    } else {
        data = new BYTE [datasize];
        mysize = datasize;
    }

    x_get_pbm( x, y, width/4, height, ScrnOffs, data );
}

void bitmap::CSetData( BYTE far *idata )
{
    if ( !idata ) {
       printf("Error: bitmap::CSetData   in data (idata) is null.\n");
       return ;
    }
    if ( data )
                delete data;
    data = idata;
}

bitmap& bitmap::operator=( const bitmap &y )
{
    if (this != &y) {
        (*this).data = y.data;
        (*this).next = y.next;
    }
    return *this;
}

void bitmap::CSize( int orig, int dest )
{
    if (orig == dest) return;
   printf("sizing bitmap from size %d to size %d\n", orig, dest );
}

int bitmap::CLoad( char *filename )
{
    if (!filename) {
       printf("Error: bitmap::CLoad  null filename.\n");
       return 0;
    }
   printf("load bitmap file %s.\n", filename);
   return 0;
}

//
// sprite memeber functions
//

bitmap* sprite::CAdvance( WORD ScrnOffs )
{
    if ( !current )
        current = firstbmp;

    current->CPutMasked( x, y, ScrnOffs );
   current = current->next;

    if ( !current ) {
       printf("Error: sprite::CAdvance   result current is null.");
    }

    return current;
}


void   sprite::CRefresh( WORD ScrnOffs )
{
    if (!current) return;
    current->CPutMasked( x, y, ScrnOffs );
}

sprite::~sprite ()
{
   bitmap *tmpPtr;

    if (firstbmp) {

        lastbmp->next = 0;

        while (firstbmp) {

            tmpPtr = firstbmp;
            firstbmp = firstbmp->next;

            delete tmpPtr;
        }
    }
}

bitmap* sprite::CAdd( bitmap *newbmp )
{
    bitmap *tmpPtr;

    if (newbmp)
               tmpPtr = newbmp;
    else
                tmpPtr = new bitmap();

    if ( !tmpPtr ) {
       printf("Error:  sprite::CAdd   tmpPtr is null.\n");
    }

    if (!firstbmp)
        current = firstbmp = lastbmp = tmpPtr;

    else {

        lastbmp->next = tmpPtr;
        lastbmp = tmpPtr;

    }

    lastbmp->next = firstbmp;
    return tmpPtr;
}

sprite& sprite::operator=( const sprite &spr )
{
    if (this != &spr) {
        (*this).firstbmp = spr.firstbmp;
        (*this).lastbmp = spr.lastbmp;
        (*this).current = spr.current;
        (*this).x = spr.x;
        (*this).y = spr.y;
        (*this).width = spr.width;
        (*this).height = spr.height;
    }
    return *this;
}


//andout   BYTE far* readfile(char *filenamein ){

   char far* _pascal_ readfile(char *filenamein ){  //andin

    BYTE far *ibuff = NULL;
    unsigned infilesize, nread;
    FILE *fi;

   fi = fopen( filenamein,"rb+" );
   if ( !fi ) return 0;

   fseek ( fi, 0, SEEK_END );
   infilesize = (unsigned) ftell(fi);
   fseek ( fi, 0, SEEK_SET );

    ibuff = new BYTE far[infilesize];
    if ( !ibuff ) return 0;

    int fih = fileno( fi );
    _dos_read( fih, ibuff, infilesize, &nread );

    if ferror( fi ) return 0;

    fclose(fi);
    return ibuff;
}


#define SPRITE_WIDTH 24

#ifndef NormalTimer
#define LOOP_DELAY 8
#else
#define LOOP_DELAY 1
#endif



