#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <conio.h>

#include "macros.h"
#include "fileio.h"
#include "debug.h"
#include "vidinter.h"
#include "mouinter.h"

void v_ResetColors( void )
{
    FaceColor = 7;          // grey
    BtnUpColor = 15;         // white
    BtnLowColor = 8;        // dark grey
    HighLiteColor = 12;      // bright orange
    OutLineColor = 4;       // Red
    TextColor = 9;          // blue
}

//
// Initialize graph
//
int tcgraph_Init(void)
{
    int gdriver, gmode, errcode;
    char gpath[128];
    FILE *ini;
    ini = fopen( "tbgraph.ini", "r");
    gpath[0] = 0;
    if ( ini ) {
        fgets( gpath, 128, ini );
        gpath[strlen(gpath)-1] = 0;
        fclose(ini);
    }
    v_ResetColors();
    do {
        gdriver = VGA;
        gmode = VGAHI;
        printf("path: |%s|\n", gpath );
        initgraph( &gdriver, &gmode, gpath );
        errcode = graphresult();
        if ( errcode == grOk ) break;
        else {
            printf("\nGraphics error: %s\n", grapherrormsg(errcode));
            switch( errcode ) {
                case grFileNotFound:
                    printf("Enter the correct path: ");
                    gets(gpath);
                    break;
                default:
                    printf("Press a key to stop.");
                    getch();
                    exit(1);
            }
        }
    } while( 1 );
    m_MouseInit;
//    m_ShowMouse;
    return 1;
}


void tcgraph_DeInit(void)
{
    closegraph();
}

void _pascal_ _Line( int x1, int y1, int x2, int y2, int color )
{
    setcolor(color);
    line(x1, y1, x2, y2 );
}

void _pascal_ _XLine( int x1, int y1, int x2, int y2, int color )
{
    setcolor(color);
    setwritemode( XOR_PUT );
    line(x1, y1, x2, y2 );
    setwritemode( COPY_PUT );
}

//
// Draw a rectangle filled with color
//
void _pascal_ __RectFill( int x1, int y1, int x2, int y2, int color )
{
    static char solid[] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
    setcolor(color);
    setfillpattern(solid, color);
    bar( x1, y1, x2, y2 );
}

void _pascal_ __Rectangle(  int x1, int y1, int x2, int y2, int color )
{
    setcolor(color);
    rectangle( x1, y1, x2, y2 );
}

void _pascal_ __XRectangle(  int x1, int y1, int x2, int y2, int color )
{
    setcolor(color);
    setwritemode( XOR_PUT );
    rectangle( x1, y1, x2, y2 );
    setwritemode( COPY_PUT );
}

int _pascal_ v_StrPixelLen( char *str )
{
    return strlen(str)*v_CharWidth('M');
}


int _pascal_ __PrintMsg(int x, int y, int fc, int bc, int len, char *str)
{
    int y2;
    len += x;
    y2 = y + v_CharHeight();

    v_RectFill( x, y, len, y2, bc );
    setcolor( fc );
    outtextxy( x, y, str );
    return x + len;
}


int _pascal_ __PrintMsgMA(int x, int y, int fc, int bc, int len, char *str)
{
    if ( !str ) return x;
    int x1, y1, y2;

    x1 = x - 8;
    y1 = y - 13;
    len += x;
    y2 = y + v_CharHeight();

    if ( MouseInRect (x1, y1, len, y2))
                                        m_HideMouse;
    v_RectFill( x, y, len, y2, bc );
    setcolor( fc );
    outtextxy( x, y, str );

    m_ShowMouse;
    return x + textwidth(str);
}


int _pascal_ v_LimitPixelPrint(int x, int y, int fc,
                                int bc, int len, char *str )
{
    int y2, i;
    char c = 0;

	if ( !str ) return x;
    y2 = y + v_CharHeight();

    i = len/v_CharWidth( 'M' );
    if ( i <= strlen(str)) {
        c = str[i];
        str[i] = 0;
    }

	len += x;
    v_RectFill( x, y, len, y2, bc );

    setcolor(fc);
    outtextxy( x, y, str );

    if ( c ) str[i] = c;

    return i * v_CharWidth('M');
}

int _pascal_ v_StrPixelLenUpTo( char *str, int slen, int plen )
{
    int len = slen * v_CharWidth('M');
    if ( len > plen ) len = plen;
    return --len;
}


char* _pascal_ v_StrToFitPixels( char *begin, char *end, int len, int &newPos)
{
	int x = 0;

    while( *end ) {
        x += v_CharWidth('M');
        if ( end == begin || x > len ) break;
        end --;
	}

	if ( x > len ) {
        end ++;
	}
    newPos =(int)( end - begin );

    return end;
}

int _pascal_ v_CenterMsgY( int y1, int y2 )
{
	return ( y2 - y1 - v_CharHeight()) / 2 + y1 + 1;
}

int _pascal_ v_CenterMsgX( int x1, int x2, char *msg )
{
    return ( x2 - x1 - v_StrPixelLen( msg )) / 2 + x1;
}

WORD _pascal_ v_BMPsize( int w, int h )
{
    return imagesize( 0, 0, w, h );
}
