#include <stdio.h>
#include "viewmgr.h"
#include "vidinter.h"
#include "timer.h"
#include "debug.h"
#include "actids.h"
#include "button.h"

#ifdef __MSDOS__
#include <dos.h>
#include <conio.h>
#endif

#define delayTime 10
#define downDelay 10

BYTE    ViewMgr::ButtonStatus = 0;
BYTE    ViewMgr::ButtonDown = 0;
BBOOL   ViewMgr::objFocus = FALSE;
#ifdef TRACE_MOUSE
BBOOL   ViewMgr::TraceMouse = TRUE;
#endif
Timer   ViewMgr::downTimer = 0;
Timer   ViewMgr::DCTimer = 0;
int     ViewMgr::nClickCount = 0;
ScrObj* ViewMgr::WorkObj = 0;
Message* ViewMgr::otoSender = 0;
Message* ViewMgr::otoTail = 0;

// Global Variables

ObjMgr	*CurrentMgr = 0;	// point to current manager in control
int 	objMouseX = 0;		// mouse x for objects (see header file)
int 	objMouseY = 0;		// mouse y for objects
int debug = 0;
static int ScrnLtX = 0, ScrnTpY = 0, ScrnRtX = v_Width - 10, ScrnBtY = v_Height - 10;

char *MouBitmapCur = 0;
static RodentOldx, RodentOldy;
int RodentHidden = 1;
BYTE far SaveMouse[100];
BYTE far MouCurDef[]={ 2, 12, 115, 0, 115, 0, 115, 0, 115, 0, 115, 115,
    115, 116,
    115, 115, 115, 0, 115, 117, 115, 117, 115, 117, 0, 0, 0, 0, 115, 0, 
    116, 0, 116, 0, 116, 0, 116, 115, 116, 0, 116, 0, 116, 0, 115, 117, 
    0, 0, 0, 0, 0, 0, 0, 0, 115, 0, 116, 0, 117, 0, 117, 0, 117, 0, 116, 
    0, 115, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 115, 0, 116, 0, 116, 
    0, 116, 0, 115, 0, 117, 0, 117, 0, 117, 0, 117, 0  };

// End of global variables

void  _pascal_ ViewMgr::CResetObjectHandler( void )
{
    // static members
    ButtonStatus = ButtonDown = 0;
    WorkObj = 0;
    objFocus = FALSE;
#ifdef TRACE_MOUSE
    TraceMouse = TRUE;
#endif

    // global variables
    objMouseX = 0;
    objMouseY = 0;
}

void  _pascal_ ViewMgr::CMakeMouseOnNoObject( void )
{
    WorkObj = 0;
	ButtonDown = 0xf1; // invalidate buttondown
}

void  _pascal_ ViewMgr::CToggleObjectFocus( void )
{
    objFocus = !objFocus;
    /*
	if ( objFocus ) objFocus = 0;
	else            objFocus = 1;
    */
}


void  _pascal_ ViewMgr::CReset( void )
{
    Current = 0;
}

int   _pascal_ ViewMgr::CMgrLoop        (void )
{
	ViewMgr* OldMgr = (ViewMgr*)CurrentMgr;
	ScrObj * objPtr;

	if ( OldMgr ) {
		objPtr = (ScrObj*)OldMgr->Current;
        if ( objPtr )
            objPtr->CRestoreOutLine();
	}
	CShowObject();

    m_ShowMouse;
	return ObjMgr :: CMgrLoop();
}

ViewMgr&  _pascal_ ViewMgr::operator= (const ViewMgr &y)
{
    if (this != &y ) {
		ObjMgr::operator = (y);
        ScrObj::operator = (y);
    }
    return *this;
}

void  _pascal_ ViewMgr::AdvanceMsg( void )
{
    otoSender = otoSender->next;
    if ( !otoSender ) otoTail = 0;
}


void _pascal_ ViewMgr::CSendMsg( Object *tg, int id,
                        Object *src, BYTE _mb, int key )
{
    if ( !tg ) return;
    Message *tmpMsg = new Message( tg, id, src, _mb, key );
    if ( !tmpMsg ) {
        beep( 500, 100 );
        return;
    }
    if ( otoTail ) otoTail->next = tmpMsg;
    else           otoSender = tmpMsg;
    otoTail = tmpMsg;
}

void _pascal_ ViewMgr::CLinkSendMsg( Object *tg, int id,
                            Object *src, BYTE _mb, int key )
{
    while ( tg ) {
        CSendMsg( tg, id, src, _mb, key );
        tg = tg->next;
    }
}
void  _pascal_ ViewMgr::CShowAllObject( void )
{
    if (ObjHead)
        ((ScrObj*)ObjHead)->CLinkShowObject();
}

int _pascal_ ViewMgr::CAddClick( const Message *msg )
{
    static ScrObj* lastObj;
    static BYTE Clicked;

    if (Clicked == msg->mouButton &&
        lastObj == (ScrObj*)msg->ToObj &&
        DCTimer.time() < delayTime )        {

        debug_msg( "add Click. \n" );
        nClickCount ++;
    } else if ( downTimer.time() < downDelay ) {

        lastObj = (ScrObj*)msg->ToObj;
        nClickCount = 1;
        Clicked = msg->mouButton;
        DCTimer.start();
    }

    return nClickCount;

}

static void _pascal_ ShowBorder( Object* obj, BBOOL draw = TRUE )
{
    if ( draw ) ((ScrObj*)obj)->CHighLiteOutLine();
    else ((ScrObj*)obj)->CRestoreOutLine();

    m_ShowMouse;
}


BBOOL  _pascal_ ViewMgr::VerifyObject( void )
{
    if ( objFocus ) return FALSE;
	WorkObj = (ScrObj*) Current;
    if ( WorkObj && WorkObj->CMouseInMe() )
        return TRUE;
	else {
        // Find the object mouse points to
        WorkObj = (ScrObj*)ObjHead;
        while ( WorkObj ) {
            if ( WorkObj->CMouseInMe() ) break;
            WorkObj = (ScrObj*)WorkObj->next;
        }
    }
	if ( WorkObj ) {
        Current = WorkObj;
        return TRUE;
    }
    return FALSE;
}

#ifdef TRACE_MOUSE
void  _pascal_ ViewMgr::CheckMouseTrace( void )
{
    static int oldMx, oldMy;
    static int newMx, newMy;
    static Object *sentoff = 0;

	oldMx = newMx;
	oldMy = newMy;
	newMx = m_MouseX;
	newMy = m_MouseY;

	if (oldMx != newMx || oldMy != newMy ) {

		objMouseX = newMx;
		objMouseY = newMy;

        if ( !objFocus && !ButtonStatus ) {

            WorkObj = (ScrObj*) Current;

            if ( !(WorkObj && WorkObj->CMouseInMe()) ) {
                if ( WorkObj && WorkObj != sentoff ) {
                    if ( debug )
                        printf("sent mouse off.\n");
                    ViewMgr::CSendMsg( WorkObj, MOUSE_OFF, 0, 0 );
                    ShowBorder( WorkObj, FALSE );
                    sentoff = WorkObj;
                }

                // Find the object mouse points to
                WorkObj = (ScrObj*)ObjHead;
                while ( WorkObj ) {

                    if ( WorkObj->CMouseInMe() ) break;
                    WorkObj = (ScrObj*)WorkObj->next;
                }
            }
            // Did we find an object?
            if ( WorkObj ) {
                if ( debug )
                    printf("found\n");
                ViewMgr::CSendMsg( WorkObj, MOUSE_ON, 0, 0 );
                ShowBorder( WorkObj );
                Current = WorkObj;
                sentoff = 0;
            }
        }
    }
}
#endif

void _pascal_ MouseHVSpeed( int h = 8, int v = 8)
{
	_asm {
		mov ax, 15
        mov cx, h
        mov dx, v
		int 33h
	}
}

void  _pascal_ ViewMgr::KeyBoardHandler( void )
{
    static slow = 0;
    if ( kbhit() ) {
        int key = getch();
        if ( !key ) key = getch() + 0xff;
        switch ( key ) {
            case 314:
                debug = !debug;
                break;
            case 315:
                if ( slow )
                    MouseHVSpeed();
                else
                    MouseHVSpeed( 25, 25 );
                slow = !slow;
                break;
            case 389:
                stop = 1;
                break;
            default:
                break;
        }
        CSendMsg( WorkObj, KEY_DOWN, 0, 0, key );
    }
}

void _pascal_
ViewMgr::MouseHandler ( void )
{
	// Read mouse button status
	ButtonStatus = m_MouseButtonStatus;

	// check if button status have change since last time
    if (( ButtonDown != ButtonStatus )) {
        // Record Mouse Coordinates
		objMouseX = m_MouseX;
		objMouseY = m_MouseY;

        // Button is now up, but it was on an object.  So it's a click
        if ( !ButtonStatus && ButtonDown && WorkObj) {

            DCTimer.stop();     // Stop the double click timer
            downTimer.stop();   // Stop the holding button timer

            // Make sure the cursor is still on object before send click
            if (WorkObj->CMouseInMe() )

                CSendMsg( WorkObj, 0, 0, (BYTE)ButtonDown | CLICK );
            else
            // otherwise tell object the click is canceled
                CSendMsg( WorkObj, CANCEL_CLICK, 0, 0 );

        // Otherwise the button is being pushing down
        } else if ( ButtonStatus ) {

            // if mouse was holding on an object, let the object
            // know that mouse is gone
            if ( ButtonDown && Current )
                CSendMsg(WorkObj,CANCEL_CLICK,0, 0 );

            // Make sure the mouse is not click outside the viewing window
			if (slave && !this->CMouseInMe() && CGiveUpControl() ) {

                stop = 1;
                WorkObj = 0;
                return;

            // Call VerifyObject to obtain a new object
            } else if ( VerifyObject() )

                // VerifyObject found that mouse is pushed down on an object
                // and WorkObj is now point to that object
                CSendMsg( WorkObj, 0, 0, (BYTE)ButtonStatus|HOLD );

            // Restart the timer to count how long the button is holding down
            downTimer.start();
		}
        // And save the status of the mouse button to ButtonDown
        ButtonDown = ButtonStatus;

    } else if (ButtonDown && WorkObj ) {  // keep sending HOLD

		objMouseX = m_MouseX;
		objMouseY = m_MouseY;

        if ( WorkObj->CMouseInMe() )
            CSendMsg(WorkObj, 0, 0, (BYTE)ButtonDown|HOLD);
        else
            CSendMsg(WorkObj, MOUSE_OFF, 0, 0 );
	}
#ifdef TRACE_MOUSE
    else if ( TraceMouse )   CheckMouseTrace();
#endif
}

// ** This is the ViewMgr's object handler
void _pascal_
ViewMgr::ObjHandler (void )
{
#ifdef __XLIB__
    int m = 0;
    if ( m_MouseX < ScrnLtX ) {
        m = 1;
        ScrnLtX = m_MouseX;
    } else if ( m_MouseX > ScrnRtX ) {
        m = 1;
        ScrnLtX += ( m_MouseX - ScrnRtX );
    }
    if ( m_MouseY < ScrnTpY ) {
        m = 1;
        ScrnTpY = m_MouseY;
    } else if ( m_MouseY > ScrnBtY ) {
        m = 1;
        ScrnTpY += ( m_MouseY - ScrnBtY );
    }
    if (m ) {
        ScrnRtX = ScrnLtX + v_Width - 10;
        ScrnBtY = ScrnTpY + v_Height - 10;
        x_set_start_addr( ScrnLtX, ScrnTpY );
    }
#else
#error bogus
#endif
	// Check object to object communication
    if ( otoSender ) {
        static Object *tmpObjPtr;
        Message *tmpMsgPtr = otoSender;

//        AdvanceMsg();
        otoSender = otoSender->next;
        if ( !otoSender ) otoTail = 0;

        tmpObjPtr = tmpMsgPtr->ToObj;

        if (tmpObjPtr && tmpObjPtr->sHandler )
			tmpObjPtr->sHandler( tmpMsgPtr );

        delete tmpMsgPtr;
    } else {
        if ( m_MouseX != RodentOldx || m_MouseY != RodentOldy || RodentHidden ) {
            if ( !RodentHidden )
                v_Putbmp( RodentOldx, RodentOldy, SaveMouse );
            RodentHidden = 0;
            RodentOldx = m_MouseX, RodentOldy = m_MouseY;
            x_get_pbm( RodentOldx, RodentOldy,
                       2, 12, VideoPage, SaveMouse );
            x_put_masked_pbm( RodentOldx, RodentOldy, VideoPage, MouCurDef );
        }
        KeyBoardHandler();
        MouseHandler();
    }
}

void HideRodent( void )
{
    if ( !RodentHidden ) {
        RodentHidden = 1;
        v_Putbmp( RodentOldx, RodentOldy, SaveMouse );
    }
}

// -- End of file ViewMgr.cpp -- //
