#ifndef _SPRDESG_H_
#define _SPRDESG_H_
#include "sprdesg.id"

class SprMMgr:public ViewMgr {
protected:
    virtual void  _pascal_ KeyBoardHandler( void );
    virtual void  _pascal_ ObjHandler(void );
public:
    _pascal_ SprMMgr(int x1, int y1, int x2, int y2, Object *obj = 0,
                    OBJH h = 0, WORD id = 0, BBOOL isSlave = 0 )
            :ViewMgr( x1, y1, x2, y2, obj, h, id, isSlave ) {}
    _pascal_ SprMMgr (void):ViewMgr() {}
};


#define EDITOR_INCLUSIVE_RECT(OffX, OffY) (OffX, OffY, OffX+127, OffY+127)
#define EDITOR_INCLUSIVE_WIDTH  128
#define EDITOR_INCLUSIVE_HEIGHT  128
#define MAX_SPRITE_INCLUSIVE_WIDTH 64
#define MAX_SPRITE_INCLUSIVE_HEIGHT 64

// Custom action ids

// The color chooser send this to the mouse button colors displayer and
// request a change of the color values.
#define ADJUST_PIX_SIZE             2060
#define MOU_BUT_COLOR_NONAVIGATE    2010
#define MOU_BUT_COLOR_NAVIGATE      2020
#define MOU_BUT_CHANGE_COLOR        2030
#define MARK_COLOR                  2040
#define UNMARK_COLOR                2041
#define CHANGE_LEFT_MARK_COLOR      2042
#define CHANGE_RIGHT_MARK_COLOR     2043

#define min( a, b ) ( (a) < (b) ? (a) : (b) )
#define max( a, b ) ( (a) > (b) ? (a) : (b) )

/// Maximum length of the message at bottom of the screen.
#define MSG_LEN 220
#define PIX_SIZE 4      // Initial sprite size to be edited
#define SPR_HEIGHT 32
#define SPR_WIDTH 32


#define MOVE_LEFT   1   // Sprite movement directions
#define MOVE_RIGHT  2
#define MOVE_UP     3
#define MOVE_DOWN   4

// I am 100% sure I don't have an object with id higher than 10000 :)
#define FILLED_BOUND 10000
#define FILL_CIRCLE_ID (CIRCLE_ID+FILLED_BOUND)
#define FILL_RECT_ID   (RECT_ID+FILLED_BOUND)


extern Timer friction;
extern Timer friction2;
extern SprMMgr mmgr;           // Main Object Manager
extern int OrigDisk;           // Original prompt Disk Drive
extern char *OrigWD;           // Original prompt working Directory
extern BYTE SystemPal[7][3];      // System Pallete. Colors 1-7
extern int ViewerCount;
extern WORD LeftColor, RightColor;
extern WORD tempLeftColor, tempRightColor;
extern ScrObj *MouButColor;
extern ScrObj *ColorChooserObj;
extern char _FAR_ *CanvasData;     // Memory use for working with sprites
extern char _FAR_ *DataConvert;
extern char _FAR_ *Clipboard;
extern char _FAR_ *MemPoolView;
extern char _FAR_ *MemPoolMisc;
// Indicating which of the four sprite is being edit(use by the indicators)
// These ===ARE=== ****NOT**** ARRAY indexes.  They are object ids.
extern int LeftID;
extern int RightID;
// actually Indicating which of the four spirte is being edit.  Array indexes.
extern int LeftViewIndex;
extern int RightViewIndex;


void _pascal_ MouseHVSpeed( int = 8, int = 8 );
void _pascal_ SwapColor( BYTE _FAR_ *data, int color1, int color2 );
DeclareObjH( ShowImage );


#endif
