#ifndef _STRBOX_H_
#define _STRBOX_H_
#include "classes.h"
#include "macros.h"
#include "button.h"
#include "actids.h"
#include "depend.h"
#include "string.h"
#include "timer.h"

#define cRED    29
#define cGREEN  181
#define cBLUE   61


class Caret;

class Caret {

private:
    static int x, y, y2;
    static unsigned Delay;
    static BBOOL on, draw;
    static Timer blink;
	static DeclareIntC( ShowCaret );

public:

    void  _pascal_ CSet( int ix, int iy )
        { x = ix; y = iy; y2 = y+v_CharHeight()-1; }

    void  _pascal_ CSetX( int ix )
        { x = ix; }

    void _pascal_ CSetY( int iy )
        { y = iy; y2 = y + v_CharHeight() - 1; }

    int  _pascal_  CPosX( void )                { return x; }
    int  _pascal_  CPosY( void )                { return y; }

    static void _pascal_ CDraw( void );
    static void _pascal_ CErase( void );
    void  _pascal_ CShow( void );

    void  _pascal_ CHide( void );

    void  _pascal_ CSetDelay( int d )     { Delay = d; }

};

extern Caret gTextCaret;


class StrBox:public Button {
private:

    static int  PixelLen;       // length of the frame in pixel
    static char *fptr;          // pointer to the string within frame
    static int  fptrAt,         // string position of the frame pointer
                fi;             // fi - fptrAt = string frame index
    static int  textX1;         // begin of the frame in pixel

    char *StrPtr;

    // none static member zsBname holds each individual strbox's string
    // Only one strbox can be editing at any one time.  Before editing
    // The handler will call this function to initialize all the static
    // variables above so that editing can be done.

    void  _pascal_ InitEdit( char * );
    OBJH    PrvHandler;

public:
    _pascal_ StrBox( int x1, int y1, int x2, int y2,
            WORD id = 0, char *str = 0, OBJH PrvHandler = 0 )
        :Button( x1, y1, x2, y2, CStrBoxHand, id, str ),
         PrvHandler(PrvHandler), StrPtr( 0 ) { }
    _pascal_ ~StrBox() { delete StrPtr; }

    static      DeclareObjH( CStrBoxHand );

    virtual int  _pascal_ CRestoreOutLine( void );

    virtual int  _pascal_ identify( void ) { return STRBOX_ID; }

    virtual int  _pascal_ CShowName( void );

    virtual const char*  _pascal_ CStr( void ) { return zsBname; }

    virtual int  _pascal_ CSetDefaultHand( void )
    {
        CSetHandler( CStrBoxHand );
        return 1;
    }

    virtual void  _pascal_ CShowObject( void );
};
#endif
