#ifndef _STREDIT_H_
#define _STREDIT_H_
#include "macros.h"
#include "vidinter.h"
#include <string.h>

class StrEditor {
protected:
    WORD    EditPos, // Current cursor position in string
            maxLen,  // maximum length the string is allowed to have
            len;     // Current length of the string
    BBOOL   insert, // * on => insert mode | * off => overwirte mode
            update; // on if editor data has changed
    char    *str;    // editing string pointer, duh!
public:
     _pascal_ StrEditor( char *s, WORD ML )
        :str(s), EditPos(0), insert(TRUE), maxLen(ML-1), update(TRUE)
        { len = strlen(s); }

    void  _pascal_ CSetPos( WORD pos);
    WORD  _pascal_ CPos( void )         { return EditPos; }
    void  _pascal_ CSetMaxLen( WORD ML ){ maxLen = ML - 1; }
    WORD  _pascal_ CLen( void )         { return len; }
    BBOOL _pascal_ CIsInsert( void )    { return insert; }
    void  _pascal_ CSetMode( BBOOL m )  { insert = m; }
    BBOOL _pascal_ CIsUpdate( void )    { return update; }

    // Change editing string.  Set new pos to InitPos if it's not zero
	// else keep old pos unless new string lenth is shorter
    WORD  _pascal_ CSetStr( char *s, WORD InitPos = 0 );
    char* _pascal_ CStr( void )         { return str; }

    virtual int _pascal_ addKey( int key );
    virtual int _pascal_ CEdit( int key, BBOOL forceAdd = FALSE );
};

extern StrEditor gStrEditor;

#endif
