#include <stdlib.h>
#include "vidinter.h"  // Video interface
#include "timer.h"     // Interrupt driven timer
#include "fileio.h"    // Read and write files
#include "depend.h"    // OS dependent stuff
#include "viewmgr.h"   // View manager
#include "button.h"    // Push buttons
#include "actids.h"	   // Action ids
#include "dialog.h"
#include "strbox.h"
#include "colors.h"
#include "keys.h"
#include "sprdesg.h"

#ifdef __MSDOS__
#include <dos.h>       // Needed for msdos
#include <alloc.h>
#include <conio.h>
#endif

#include "getfile.id"
#include "getfile.h"

static Button *GFOkButton;
static StrBox *FNBox;
char *FileNameStr = 0;
static char *Save = "save";
static char *Load = "load";
char *ActionString = Save;

//
// Object ID Name: TITLE_ID
//
DeclareObjH( title )
{
    ScrObj &t = *(ScrObj*)msg->ToObj;
    if ( msg->actId == REDRAW ) {
        int i;
        sprintf( buffer, "Please enter filename to be%n %s.",
                 &i, ActionString );
        int x = v_CenterMsgX( t.x1(), t.x2(), buffer ),
            y = v_CenterMsgY(t.y1(), t.y2());
        buffer[i] = 0;
        x = v_PrintMsg( x, y, TextColor, FaceColor, buffer );
        buffer[i] = ' ';
        v_PrintMsg( x, y, TextColor, BtnUpColor, buffer+i);
        m_ShowMouse;
    }
    return 0;
}

#define _I_HAVE_MY_OWN_HANDLERS_
#include "getfile.src"


//
// Object ID Name: GET_FN_OK_ID
//
// Object ID Name: GET_FN_CANCEL_ID
//
// Object ID Name: DIALOG_RECT_ID
//
DeclareObjH( GetFileDlg )
{
    static Dialog *dlg = 0;
    static installed = 0;;
    static which = 0;
    static Object *reply = 0;
    int i;

    switch( msg->actId ) {
        case -1:        // load => which == 1
        case -2:        // save => which == 0
            if ( dlg == 0 ) {
                dlg = new Dialog( 52, GFOFFY + 76, 279, GFOFFY + 156, 0, 126 );
                getfile_SetupObjects(*dlg);
                GFOkButton = (Button*)dlg->CGetObject( GET_FN_OK_ID );
                FNBox = (StrBox*)dlg->CGetObject( FILE_NAME_ID );
                // StrBox takes a char* pointer and take complete control
                // of it.  When done, CStr will return a pointer, either
                // same as the old one or a new one, to the program; deleting
                // the box won't affect the string because StrBox's destructor
                // does not deallocate the memory for the string being edit.
                // Just take of StrBox as an agent, it takes something(char*
                // pointer in this case), change it, manipulate its contents,
                // and returns it when being ask.
                FNBox->CSetName( FileNameStr );
                ViewMgr::CSendMsg( dlg, INSTALL_DIALOG, GFOkButton );
                reply = msg->Caller;
                which = msg->actId + 2;
            }
            return 0;
        case INSTALL_DIALOG:
            if ( !installed ) {
                if ( which )
                    ActionString = Load;
                else
                    ActionString = Save;
                dlg->CSendMsg( dlg->CGetObject(TITLE_ID), REDRAW );
                installed = 1;
            }
            return 0;
        case DESTROY_DIALOG:
            if ( dlg ) {
                // Get string from box before deleting the box
                // To delete the string, should do something like:
                // delete StrBox_Object->CStr();
                FileNameStr = FNBox->CStr();
                for( i = 400; i < 404; i ++ )
                    delete (dlg->CGetObject(i));
                delete dlg;
            }
            installed = 0;
            dlg = 0;
            return 0;
        case DIALOG_CONFIRM:
            if ( reply ) {
                ViewMgr::CSendMsg( reply, -1 );
                reply = 0;
            }
            return 0;
        case YESNO_YES:
            ViewMgr::CSendMsg( dlg, DIALOG_CONFIRM, GFOkButton );
            return 0;
        case 0:
        case MOUSE_OFF:
            break;
        default:
            return 0;
    }
    if ( dlg && isClick( msg, LEFT_PRESSED )) {
        if ( msg->ToObj->CGetID() == GET_FN_OK_ID ) {
            yesno( "Are you sure?(y/n)", GFOkButton );
        } else {
            ViewMgr::CSendMsg( dlg, DIALOG_CANCEL,
                            dlg->CGetObject(GET_FN_CANCEL_ID));
        }
    }
    return 0;
}

