#ifdef VID_INTERFACE

#include <vga.h>
#include <vgagl.h>

#include "mouinter.h"  // mouse functions
#define LINUX_MODE
#define _320x200
#include "modeinfo.h"  // the mode informations here


//
// functions to enter and exit graphic mode
//
#define v_SetMode   vga_setmode( MODE )
#define v_TextMode  vga_setmode( TEXT )

// Draw a rectangle and fill it with color 'color'
#define v_RectFill( x1, y1, x2, y2, color ) \
	gl_fillbox( x1, y1, x2-x1, y2-y1, color )
#define v_ButtonFaceFill( x1, y1, x2, y2, color ) \
	gl_fillbox( x1, y1, (x2)-(x1), (y2)-(y1), color )
	
// Sets the whole palette table	
#define v_PutPal( buf ) gl_setpalette( (void*) buf )

// pixel and line function
#define v_PutPixel(x, y, color ) gl_setpixel( x, y, color )
#define v_PutLine(x1, y1, x2, y2, color ) \
	gl_line( x1, y1, x2, y2, color )


//
// Bitmap functions
//
#define v_Getbmp( x, y, width, height, buf ) \
    __Getbmp( x, y, width, height, (void*)buf )
#define v_Putbmp( x, y, buf ) \
    __Putbmp( x, y, (void*)buf )


//
// User font informations
//
// #define FONT_AVAILABLE
#define FONTDIR "..\\tool\\"
#define USERFONTNAME "SMALTHIN.FNT"
#define CHARS 256
#define CHARH 8


//
// Initialize and deinitialize the video/mouse
//
int  _InitMode( void );
void _DeInitMode( void );
#define _InitVideo              _InitMode()

#define AUTO_DE_INIT

#ifndef AUTO_DE_INIT
#define _RestoreVideo           _DeInitMode()
#else
#define _RestoreVideo
#endif



//
// Some useful routines
//
void __Getbmp( int x, int y, int width, int height, void* buffer );
void __Putbmp( int x, int y, void* buffer );
void __Rectangle(int x1, int y1, int x2, int y2, int color);
void __PrintMsg(int x, int y, int len, int fc, int bc, char *str );

#define v_Rectangle( x1, y1, x2, y2, color) __Rectangle(x1, y1, x2, y2, color)
#define v_PrintMsg( x, y, len, fc, bc, s ) \
	__PrintMsg( x, y, len, fc, bc, s)
#define v_ShowMsg( x, y, len, fc, bc, s )

#endif
