#ifndef _MANAGER_H_
#define _MANAGER_H_
#include "classes.h"
#include "macros.h"
#include "object.h"

#ifdef __MSDOS__
#include <dos.h>
#endif

////////////////////////////////
//							  //
// Interceptors & Managers	  //
//							  //
////////////////////////////////

//
// Make a link list to hold the interceptors
//
class InterCs {

protected:
    INTC        InterC;
    Object      *ObjIntCPtr;
	InterCs 	*next;
public:
	friend class ObjMgr;

    _pascal_ InterCs(INTC interc, Object *ObjPtr = 0 )
        :InterC( interc ), next( 0 ), ObjIntCPtr( ObjPtr )              { }
    _pascal_ InterCs( void ): InterC( 0 ), next( 0 ), ObjIntCPtr( 0 )   { }

}; // end of class Interceptors


//
// A link list to hold objects
//
class ObjList {

protected:
	unsigned        TotalObj;
    Object          *ObjHead, *ObjTail, *Current;
    BBOOL  _pascal_ UnRegObj( Object * );

public:
    _pascal_ ObjList( Object * = 0 );
    _pascal_ ~ObjList();

    Object*  _pascal_ CGetObject      ( WORD id );
    BBOOL    _pascal_ CRegObject      ( Object * );
    BBOOL    _pascal_ CUnRegObjByPtr  ( Object * );
    BBOOL    _pascal_ CUnRegObjByID   ( WORD id );

    ObjList& _pascal_ operator=       ( const ObjList &y );
};

//
// Object manager
//
class ObjMgr: public ObjList {
protected:
	BBOOL			stop;
	static InterCs  *InterCList;
	InterCs         *PrivateInterCList;

    virtual void  _pascal_ ObjHandler ( void )          { }
	int     _pascal_ CallIntCs( InterCs *headPtr = 0 );

public:
    _pascal_ ObjMgr  (Object * = 0 );
    _pascal_ ~ObjMgr ();

    ObjMgr&  _pascal_  operator=    ( const ObjMgr &y);
    void     _pascal_ CRegInt       ( INTC, Object * = 0, BBOOL = FALSE );
    BBOOL    _pascal_ CUnRegInt     ( INTC, BBOOL = TRUE );
    virtual int   _pascal_ CMgrLoop  ( void );
    virtual BBOOL _pascal_ CGiveUpControl( void )   { return TRUE; }
    virtual void  _pascal_ CStopLoop   ( void )     { stop = TRUE; }

}; // end of class ObjMgr
//
// Current Manager in control, and btw, only one can be at any one time!
// If I ever decide to pass in the Manager pointer when calling interceptors
// and handlers, this variable will still be available.  So use it to the
// maximum that you can.  It *will* not change.
//
extern ObjMgr *CurrentMgr;

#endif
