#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NO_STATE			0
#define WAITING_STATE		100
#define POLL_FILE_NAME		200
#define WAIT_CLOSE_COMMENT 	10
#define WAIT_CLOSE_QUOTE   	20
#define WAIT_SINGLE_QUOTE  	30
#define FOUND_HEADER_FILE	40
#define WASTE_LINE			0

int walkstr( char *str );
// This is a line of comment
/* this is 
   a couple
   lines of
   comments
   did you know that? */
/* Anyways! howdy?
   yup, I know, 
   this sucks. "so what???"
   'if that this is a piece of crap'
   // then why don't you try it?
   thanks you */   

class fileName 
{
protected:
	char *fname;
	fileName *next;
public:
	friend class fileList;
	
	fileName( char *str ):fname(0), next(0) { CSetFileName( str ); }
	fileName():fname(0), next(0) {}
	~fileName() { delete fname; }
	
	FILE* COpenIt( char *attrib ) {
		FILE *f;
		if( fname ) {		
			f = fopen( fname, attrib );
			return f;
		}
		return 0;
	}
	void CSetFileName( char *str ) {
		delete fname;
		fname = new char [ strlen(str) + 1 ];
		strcpy( fname, str );
	}
	char* CGetFileName( void ) {
		return fname;
	}
};

class fileList
{
protected:
	fileName *head, *tail, *current;
public:
	fileList():head(0), tail(0), current(0) {}
	
	void CAddFileName( char *str ) {
		if( !head ) 
			head = tail = current = new fileName( str );
		else {
			tail->next = new fileName( str );
			tail = tail->next;
			if( !current ) current = tail;
		}
	}
	fileName *CNextFile( void ) {
		if( current ) {
			fileName *tmpPtr = current;
			current = current->next;
			return tmpPtr;
		}
		return 0;
	}
	int  CFileNameExist( char *str ) {
		if( head ) {
			fileName *runPtr = head;
			while( runPtr ) {
				if( strcmp( runPtr->fname, str ) == 0 )
					return 1;
				runPtr = runPtr->next;
			}
		} 
		return 0;
	}
	void CResetCurrent( void ) { current = head; }
	void CCleanUp( void ) {
		if( head ) {
			fileName *runPtr = head, *tmpPtr;
			while( runPtr ) {
				tmpPtr = runPtr;
				runPtr = runPtr->next;
				delete tmpPtr;
			}
		}
	}
	FILE *COpenCurrent( char *attrib ) {
		if( current )
			return current->COpenIt( attrib );
		return 0;
	}
};

main( int argc, char **argv )
{
	if( argc < 2 ) {
		printf("searchh filenames\n");
		exit(0);
	}
	fileList AllFiles;
	int success, fileNameCount = 1;
	char str[4096];
	FILE *fi;
	
next_file_in_argv:
	success = 0;
	AllFiles.CAddFileName( argv[ fileNameCount ] );
	while( 1 ) {
		if( (fi = AllFiles.COpenCurrent( "r" )) != 0 ) 
			while( fgets( str, 4095, fi ) != NULL ) {
				if( walkstr( str ) == FOUND_HEADER_FILE ) {
					if( !AllFiles.CFileNameExist( str ) ) 
						AllFiles.CAddFileName( str );
				}
			}
		if( !AllFiles.CNextFile() ) break;
	}
	AllFiles.CResetCurrent();
	fileName *tmpPtr;
	printf("\n-----------------------\nList of files found:");
	printf("\n-----------------------\n");
	while( ( tmpPtr=AllFiles.CNextFile() )) 
		printf("%s\n", tmpPtr->CGetFileName() );
	printf("-----------------------\n");
}

#define CPP_COMMENT '/'
#define __C_COMMENT '*'
int walkstr( char *str )
{
	static currentState = 0;
	static char waitChar1 = 0, waitChar2 = 0, getName = 0;
	char *origStr = str;
	
next_state:	
	switch( currentState ) 
	{
	case NO_STATE:
		while( *str != 0 ) {
			switch( *str ) 
			{
			case CPP_COMMENT:
				str ++;
				if( *str == CPP_COMMENT ) return WASTE_LINE;
				if( *str == __C_COMMENT ) {
					str ++;
					waitChar1 = __C_COMMENT;
					waitChar2 = CPP_COMMENT;
					currentState = WAITING_STATE;
					goto next_state;
				}
				break;
			case '"':
				str ++;

				waitChar1 = '"';
				waitChar2 = 0;
				if( getName ) {
					getName = 0;
					currentState = POLL_FILE_NAME;
					goto next_state;
				}				
				currentState = WAITING_STATE;
				goto next_state;
			case '\'':
				str ++;
				waitChar1 = '\'';
				waitChar2 = 0;
				currentState = WAITING_STATE;
				goto next_state;
			case '#':
				str ++;
				if( strncmp( str, "include", 7 ) == 0 ) {
					getName = 1;
					goto next_state;
				}
				break;
			case '<':
				str ++;
				

				if( getName ) {
/*					waitChar1 = '>';
					waitChar2 = 0; */
					getName = 0; 
					while( *str != '>' ) str++;
					currentState = NO_STATE;
					goto next_state;
				}
				break;
			default:
				str ++;
				break;
			}
					
		}
		break;
	case WAITING_STATE:
		while( *str != 0 ) {
			if(( waitChar1 == '\'' || waitChar1 == '"' ) && ( *str == '\\' )) {
				str += 2;
				continue;
			}
			if( *str == waitChar1 ) {
				str ++;
				if( waitChar2 && *str != waitChar2 )
					continue;
				else
					str ++;
				currentState = NO_STATE;
				goto next_state;
			}
			str ++;
		}
		break;
	case POLL_FILE_NAME:
		currentState = NO_STATE;
		char *tmpStr = str;
		int nameLen = 0;
		while( *str != 0 ) {
			nameLen ++;
			str ++;
			if( *str == waitChar1 ) {
				strncpy( origStr, tmpStr, nameLen );
				*(origStr + nameLen) = 0;				
				break;
			}
		}
		return FOUND_HEADER_FILE;
		
	}
	return 0;
}