#include <stdio.h>
#include "manager.h"
#include "mouinter.h"
#include "object.h"
#include "depend.h"
#include "actids.h"
#include "linklist.h"

#ifdef __MSDOS__
#include <dos.h>
#endif

#ifdef KBHIT
#include <conio.h>
#endif

/////////////////////////////////
//                             //
// IntCList member functions   //
//                             //
/////////////////////////////////
//
// CRegInt( INTC regInt  )
//
void _pascal_ IntCList::CRegInt ( INTC regInt, Object *op )
{
    INTER *temp = new INTER( regInt, op );
    if ( temp )
        if ( CAddItem( temp ) == FALSE )
            delete temp;
}

BBOOL _pascal_ IntCList::CUnRegInt ( INTC unRegInt )
{
    INTER *temp = (INTER*)ListHead;

    while( temp ) {
        if ( temp->ICFunc == unRegInt ) {
            return RemoveItem( (ListItem*)temp );
        }
        temp = (INTER*)temp->CGetNext();
    }
    return FALSE;
}

int _pascal_ IntCList::CallIntCs( void )
{
    static INTER *BackUpPtr;

    INTER *headPtr = (INTER*)ListHead;

    while( headPtr ) {
        BackUpPtr = headPtr;
        headPtr = (INTER*)headPtr->CGetNext();

        switch( BackUpPtr->CallBack() ) {
            case UNREGME:
                CUnRegInt (BackUpPtr->ICFunc );
                break;
            case UNREGMEnSTOP:
                CUnRegInt (BackUpPtr->ICFunc );
                CurrentMgr->CStopLoop();
                break;
            case STOPNOW:
                CurrentMgr->CStopLoop();
                return 0;
            default:
                break;
        }
	}
    return 1;
}


//////////////////////////////
//                          //
// ObjList member functions //
//                          //
//////////////////////////////
//
// Constructor
//
ObjList& _pascal_ ObjList::operator= ( const ObjList &y )
{
    if ( this != &y ) {
        (*this).TotalItem = y.TotalItem;
        (*this).ListHead = y.ListHead;
        (*this).ListTail = y.ListTail;
        (*this).Current = y.Current;
    }
    return *this;
}

//
// CGetObject
//      returns the pointer to an object with id
//      returns 0 for failure.
Object* _pascal_ ObjList::CGetObject (WORD id )
{
    Object *tmpObjPtr;
    tmpObjPtr = (Object*)ListHead;

    int i = 0;
    
    while (tmpObjPtr ) {
#ifdef _FATAL_FILE_
        if ( i >= TotalItem ) {
            FILE *fp = fopen( "fatal", "a+");
            fprintf( fp, "In manager.cpp: ObjList::CGetObject. CodeGt2.\n");
            fprintf( fp, "      i: %d  TO: %d  id: %d\n", i, TotalItem, id );
            tmpObjPtr = (Object*)ListHead;
            for( i = 0; i < TotalItem; i ++ ) {
                fprintf(fp, "   i: %u  id: %u\n", i, tmpObjPtr->ObjID );
                tmpObjPtr = (Object*)tmpObjPtr->next;
            }
            fclose( fp );
            while(1);
        }
#endif
        i ++;
        if (tmpObjPtr->ObjID == id )   // found
            return tmpObjPtr;
        tmpObjPtr =(Object*) tmpObjPtr->next;
    }
    return 0;

} // End of ObjList::CGetObject


Object* _pascal_ ObjList::CUnRegObjByID (WORD id )
{
    Object *tmp = (Object*)CGetObject(id);
    if ( tmp ) {
        if ( !RemoveItem( (ListItem*)tmp ))
            tmp = 0;
    }
    return tmp;
}

BBOOL _pascal_ ObjList::CDelObject( WORD id )
{
    Object *tmp = CUnRegObjByID(id);
    delete tmp;
    return( (BBOOL)(tmp != 0) );
}



/////////////////////////////
//                         //
// ObjMgr member functions //
//                         //
/////////////////////////////

//
// Initialize static member of ObjMgr
//
IntCList ObjMgr::PublicIntCs;


ObjMgr& _pascal_ ObjMgr::operator= (const ObjMgr &y)
{
    if (this != &y ) {
		(*this).stop = y.stop;
		ObjList::operator=( y );
    }
    return *this;
}


void _pascal_ ObjMgr::CRegInt ( INTC regInt, Object *ObjInt, BBOOL Private )
{
    if ( Private ) {
        PrivateIntCs.CRegInt( regInt, ObjInt );
    } else
        PublicIntCs.CRegInt( regInt, ObjInt );
}

BBOOL _pascal_ ObjMgr::CUnRegInt ( INTC unRegInt, BBOOL Private )
{
    if ( Private )
        return PrivateIntCs.CUnRegInt( unRegInt );
    else
        return PublicIntCs.CUnRegInt( unRegInt );
}


int _pascal_ ObjMgr::CMgrLoop ( void )
{
    ObjMgr   *oldMgr;   // Since we are going to take over,
                        // better save the old guy

    stop = 0;
    oldMgr = CurrentMgr;
    CurrentMgr = this;

    while ( !stop ) {
    	#ifdef __LINUX__
    	mouse_update();
    	#endif

        if ( PublicIntCs.CallIntCs() )
            PrivateIntCs.CallIntCs();
        ObjHandler ();
    }
    CurrentMgr = oldMgr;
    return 0;
}

/////////////////////////////
// End of ObjMgr functions //
/////////////////////////////
