#ifndef _MANAGER_H_
#define _MANAGER_H_
#include "classes.h"
#include "macros.h"
#include "object.h"

#ifdef __MSDOS__
#include <dos.h>
#endif

////////////////////////////////
//							  //
// Interceptors & Managers	  //
//							  //
////////////////////////////////


//
// Make a link list to hold the interceptors
//
class INTER:public ListItem {
protected:
    INTC        ICFunc;
    Object      *ObjPtr;

public:
    friend class IntCList;

    _pascal_ INTER(INTC interc, Object *op = 0 )
        :ICFunc( interc ), ObjPtr( op )              { }
    _pascal_ INTER( void ): ICFunc( 0 ), ObjPtr( 0 )   { }

    _pascal_ int CallBack( void ) { return ICFunc(ObjPtr); }

}; // end of class Interceptors


class IntCList:public LinkList {
public:
    _pascal_ IntCList( void )   {}
    _pascal_ ~IntCList( void )  {}

    void     _pascal_ CRegInt    ( INTC, Object * = 0 );
    BBOOL    _pascal_ CUnRegInt  ( INTC );
    int      _pascal_ CallIntCs  ( void );
};


class ObjList:public LinkList {

public:
    _pascal_ ObjList(void):LinkList() {}
    _pascal_ ~ObjList() {}

    virtual  BBOOL _pascal_ CRegObject( Object *obj )
    {
        return CAddItem( (ListItem*)obj );
    }
    Object*  _pascal_ CGetObject      ( WORD id );
    Object*  _pascal_ CUnRegObjByID   ( WORD id );
    BBOOL    _pascal_ CDelObject      ( WORD id );
    ObjList& _pascal_ operator=       ( const ObjList &y );
};


//
// Object manager
//
class ObjMgr: public ObjList {
protected:
	BBOOL			stop;
    static IntCList PublicIntCs;
    IntCList        PrivateIntCs;

    virtual void  _pascal_ ObjHandler ( void )          {}

public:
    _pascal_ ObjMgr  (void)
        :ObjList(), stop(FALSE)             {}
    _pascal_ ~ObjMgr ()                     {}

    ObjMgr&  _pascal_ operator=    ( const ObjMgr &y);
    void     _pascal_ CRegInt      ( INTC, Object * = 0, BBOOL = FALSE );
    BBOOL    _pascal_ CUnRegInt    ( INTC, BBOOL = TRUE );
    virtual int   _pascal_ CMgrLoop  ( void );

    virtual BBOOL _pascal_ CGiveUpControl( void )   { return TRUE; }
    virtual void  _pascal_ CStopLoop   ( void )     { stop = TRUE; }

}; // end of class ObjMgr

//
// Current Manager in control.  This will always points
// to the manager currently running.
//
extern ObjMgr *CurrentMgr;

#endif
