#ifndef _PCX_H_
#define _PCX_H_

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef _pascal_
#define _pascal_ _pascal
#endif

#define PCX_MANUFACTURER    0
#define PCX_MAN_SIG         10
#define PCX_VERSION         1
#define PCX_ENCODE          2
#define PCX_BITS_PER_PIX    3
#define PCX_XMIN            4
#define PCX_YMIN            6
#define PCX_XMAX            8
#define PCX_YMAX            10
#define PCX_HRES            12
#define PCX_VRES            14
#define PCX_COLORMAP        16
#define PCX_RESERVED        64
#define PCX_NPLANES         65
#define PCX_BYTES_PER_LINE  66
#define PCX_PAL_INFO        68

//
// Minimum size of a version 5 pcx file(header size + 256color pal data)
//
#define PCX_MINSIZE         (128L+769L)
//
//     PCX Version information:
//        0 = Version 2.5
//        2 = Version 2.8 w/palette information
//        3 = Version 2.8 w/o palette information
//        5 = Version 3.0
//

//
//        How to interpret palette
//                1 = color/BW,
//                2 = grayscale
//

typedef struct zPCXHeader
{
    BYTE Manufacturer;
    BYTE Version;
    BYTE Encode;
    BYTE BitsPerPix;
    short int XMin;
    short int YMin;
    short int XMax;
    short int YMax;
    short int HRes;
    short int VRes;
    BYTE ColorMap[48];
    BYTE Reserved;
    BYTE NPlanes;
    short int BytesPerLine;
    short int PalInfo;
    BYTE Filler[58];
} PCXHeader;

#define PCX_RW_BUF_SIZE 512
#define READ_PCX        1
#define WRITE_PCX       2

class PCXAgent
{
protected:
    static BYTE buffer[PCX_RW_BUF_SIZE];
    //
    // Bytes need to hold one complete uncompressed scan line:
    //
    PCXHeader myHeader;

    int opened, x, y, OpenMode;

    void  _pascal_ RollLine( int, int );
    char* _pascal_ RollData( char *buf, int size );
    int   _pascal_ PackLine( BYTE &, BYTE & );
    int   _pascal_ PackBuf ( BYTE * );

    int _pascal_ SaveHeader( void );

public:
    _pascal_ PCXAgent( void ):opened(-1) {}
    _pascal_ ~PCXAgent() {}

    int _pascal_ Open( char *name, int mode = READ_PCX );
    int _pascal_ Close( void );
    int _pascal_ Valid( void );
    int _pascal_ ReadHeader( void );
    int _pascal_ Read256Pal( BYTE *data );
    int _pascal_ Save256Pal( BYTE *data );
    PCXHeader   &GiveHeader( void ) { return myHeader; }
    int _pascal_ Show( void );
    int _pascal_ Save( void );

};

extern PCXAgent PCXFile;

#endif

