#include "stredit.h"
#include "macros.h"
#include "keys.h"
#include <ctype.h>
#include <stdio.h>

#ifndef _DEPEND_H_
#error OS/Graphic Dependent information is not available.
#endif

#ifdef __MSDOS__
#include <dos.h>
#endif

// #define TEST_EDITOR

WORD _pascal_ StrEditor::CSetStr( char *s, WORD InitPos )
{
    if ( !s ) return 0;

    len = strlen( s );
    if ( len > maxLen )                 return 0;
    if ( EditPos > len )                EditPos = len;
    if ( InitPos && InitPos <= len )    EditPos = InitPos;
    str = s;
    update = TRUE;
    return EditPos;
}

void _pascal_ StrEditor::CSetPos( WORD pos )
{
    if ( pos <= len ) {
        EditPos = pos;
		update = TRUE;
	}
}

#define i EditPos

int _pascal_ StrEditor::addKey( int key )
{
    if ( len < maxLen ) {
        if ( !insert ) {
            if ( !str[i] )
                str[++len] = 0;
            str[i++] = (char)key;
        } else if ( !str[i] ) {
			str[i++] = (char)key;
            str[++len] = 0;
        } else {
            memmove( (void*)(str + i + 1), (void*)(str + i),
                        (size_t)(len - i) );
            str[i++] = (char)key;
            str[++len] = 0;
		}
		return 0;	// key added to string content
	} else {
		beep( 1000, 5 );
        update = FALSE;
		return -1;	// string full
    }
}

int _pascal_ StrEditor::CEdit( int key, BBOOL forceAdd )
{
    if ( !str ) return 0;
    update = TRUE;
    if ( forceAdd ) {
        return addKey( key ); // return 0 if key added to string content
                              // otherwise return -1 (string is full)
    }
    switch( key ) {
    case INSERT:
        if ( insert == FALSE )  insert = TRUE;
        else                    insert = FALSE;
        break;
    case BACKSPACE:
        if ( i ) {
            i --;
            if ( str[i] )
                memmove( (void*)(str+i), (void*)(str+i+1),
                        (size_t)(len - i));
            else
                str[i] = 0;
			len --;
            return 0; // key affected string content
		}
		break;
	case DELETE:
		if ( str[i] ) {
			memmove( (void*)(str+i), (void*)(str+i+1),
					(size_t)(len - i ));
			len --;
            return 0;   // key affected string content
		}
        break;
    case HOME:
    // Only update if i != 0(Not already at home position).
    // So we will not refresh string on screen when user press home everytime.
        i = 0;
        return key;  // key did not affected string content
	case END:
    // ditto (except update when i != len )
        i = len;
        return key;  // key did not affected string content
	case LEFT:
        if ( i ) {
            i --;
            return key;   // ditto
        }
        break;
	case RIGHT:
        if ( str[i] ) {
            i ++;
            return key;  // ditto
        }
        break;
	default:
        // Don't know what it is, so add it to string if it's printable
        if ( isprint(key) ) return addKey( key );
	}
    // Key not recognized, return it
    update = FALSE;
    return key;
}

StrEditor gStrEditor(0,0);

#ifdef TEST_EDITOR
#include <stdio.h>
#include <conio.h>

main ()
{
	char str[1024];
	strcpy( str, "Please Type in your name: " );
	if ( !gStrEditor.CSetStr( str, 1 )) {
		printf("Can't set string for editing.\n");
		return 0;
	}
	gStrEditor.CSetPos( 0 );
	int key = 0;
	clrscr();
	do {
        if ( gStrEditor.CIsUpdate()) {
            gotoxy( 1, 10 );
            printf( "%s ", gStrEditor.CStr() );
            gotoxy( gStrEditor.CPos() + 1, 10 );
        }
		key = getch();
		if ( !key ) key = getch() + 0xff;
	} while ( gStrEditor.CEdit( key ) != ESC );
	return 0;
}

#endif
