#include "dialog.h"
#include "macros.h"
#include "actids.h"
#include "button.h"
#include "vidinter.h"
#include <conio.h>
#include "keys.h"

class YN_Dlg : public Dialog
{
private:
    static YN_Dlg *AskDlg;
	static Button *Confirm, *Cancel;
	static Object *requester;
	static char *questionStr;
protected:
    YN_Dlg( char *s, Object *req, Object *object = 0, WORD id = 0 );
	virtual void _pascal_ KeyBoardHandler( void );
public:
	static DeclareObjH( YesNoHandler );

    friend BBOOL _pascal_ yesno( char *s, Object *req );
};

YN_Dlg* YN_Dlg::AskDlg = 0;
Button* YN_Dlg::Confirm;
Button* YN_Dlg::Cancel;
Object* YN_Dlg::requester;
char  * YN_Dlg::questionStr;

void _pascal_ YN_Dlg::KeyBoardHandler( void )
{
    while ( kbhit() && !EndDialog ) {
		switch( (char)getch()) {
		case 'N':
		case 'n':
			ViewMgr::CSendMsg( AskDlg, DIALOG_CANCEL, 0, 0 );
			break;
		case ENTER:
		case 'Y':
		case 'y':
			ViewMgr::CSendMsg( AskDlg, DIALOG_CONFIRM, 0, 0 );
			break;
		}
	}
}

#define DLG_Y1 110
#define DLG_Y2 150

DeclareObjHClass( YN_Dlg, YesNoHandler )
{
    static confirm_id = 0;
    Object *t = (Object*)msg->ToObj;
	WORD id = t->CGetID();

    if ( msg->actId && id ) {
		switch( msg->actId ) {
		case DESTROY_DIALOG:
            ViewMgr::CSendMsg( requester, confirm_id, 0, 0 );
			delete Confirm;
			delete Cancel;
			delete AskDlg;
            AskDlg = 0;
            break;
		case DIALOG_CONFIRM:
            confirm_id = YESNO_YES;
            break;
        case DIALOG_CANCEL:
            confirm_id = YESNO_NO;
            break;
		case INSTALL_DIALOG:
            v_PrintMsg( v_CenterMsgX( AskDlg->x1(), AskDlg->x2(),questionStr),
						DLG_Y1 + 4, TextColor, FaceColor, questionStr );
            break;
        default:
			Button::CAction( msg );  // Process mouse event
		}
    } else if ( isClick( msg, LEFT_PRESSED )) {
		int action = ( id ? DIALOG_CONFIRM : DIALOG_CANCEL );
		ViewMgr::CSendMsg( AskDlg, action, 0, 0 );
	}

    m_ShowMouse;

	return 0;
}

YN_Dlg :: YN_Dlg(char *s, Object *req, Object *object, WORD id)
    : Dialog( 0, 0, 0, 0, object, id )
{
	requester = req;
	questionStr = s;
	int x1, x2;
	x2 = v_StrPixelLen( s );

	if ( x2 < 90 ) x2 = 90;

	x1 = (v_XMax - x2) / 2 - 4;
	x2 = v_XMax - x1;

	int x = ( x2 + x1 - 90 ) / 2;

	Confirm = new Button( x, 132, x + 30, 146, YesNoHandler, 1, "Yes" );
	Cancel  = new Button( x + 60, 132, x + 90, 146, YesNoHandler, 0, "No");
	CRegObject( Confirm );
	CRegObject( Cancel );
    AskDlg = this;
    CSetUpper( x1, DLG_Y1 );
    CSetLower( x2, DLG_Y2 );
	CSendMsg( AskDlg, INSTALL_DIALOG, Confirm, 0 );
}


BBOOL _pascal_ yesno( char *s, Object *req )
{
    if ( !YN_Dlg :: AskDlg ) {
        new YN_Dlg( s, req );
        return TRUE;
    } else
        return FALSE;
}
