#include "actids.h"
#include "button.h"
#include "vidinter.h"
#include "viewmgr.h"
#include <string.h>
#include <dos.h>


// Uncomment next line will turn off 3d outline for this file.

//#undef OUTLINE_3D

int _pascal_ Button::CRestoreOutLine( void )
{
    if ( (ScrObj*)this != HighLite ) {
        return 0;
    }
    HighLite = 0;

    m_HideMouse;
#ifdef OUTLINE_3D
    CDraw3DOutLine();
    CDraw3DOutLine( FALSE, TRUE );
#else
    CDraw3DOutLine();
#endif
    return FaceColor;
}

int  _pascal_ Button::CHighLiteOutLine( void )
{
    if ( HighLite )
        if ( HighLite != (ScrObj*)this )
            HighLite->CRestoreOutLine();
        else
            return 0;
    HighLite = (ScrObj*)this;
    m_HideMouse;
#ifdef OUTLINE_3D
    CDraw3DOutLine( TRUE );  // down = true
    CDraw3DOutLine( FALSE, TRUE );
#else
    ScrObj::CDrawOutLine( HighLiteColor );
#endif
    return FaceColor;
}

Button& _pascal_ Button::operator= (const Button &y)
{
    if (this != &y ) {
        (*this).bface = y.bface;
        (*this).zsBname = y.zsBname;
        ScrObj::operator = (y);
    }
    return *this;
}

void _pascal_ Button::CDraw3DOutLine( BBOOL Down, BBOOL _3D2 )
{
	int upColor, lowColor;
	if ( Down ) {
		upColor = BtnLowColor;
		lowColor = BtnUpColor;
	} else {
		upColor = BtnUpColor;
		lowColor = BtnLowColor;
	}
    int x1, y1, x2, y2;
    x1 = sX1;
    y1 = sY1;
    x2 = sX2;
    y2 = sY2;
    if ( _3D2 ) {
        x1--;
        y1--;
        x2++;
        y2++;
    }
    v_PutLine (x2, y1, x2, y2, lowColor );
    v_PutLine (x1, y2, x2, y2, lowColor );
    v_PutLine (x1, y1, x2, y1, upColor );
    v_PutLine (x1, y1, x1, y2, upColor );
}

void _pascal_ Button::CDrawFace()
{
	CClrContext( FaceColor );
    if ( bface ) {
        if ( FaceMask == MASKED_FACE )
            v_PutMaskedbmp( FaceX+sX1, FaceY+sY1, bface );
        else
            v_Putbmp( FaceX+sX1, FaceY+sY1, bface );
    } else
        CShowName();
}

int _pascal_ Button::CShowName( void )
{
    if ( zsBname )
        return v_ShowMsg( CCenterMsgX(), CCenterMsgY(),
                           TextColor, FaceColor, zsBname );
    else
        return sX1+2;
}


void _pascal_ Button::CShowObject()
{
    CHighLiteOutLine();
    CRestoreOutLine();
    CDrawFace();
    CDraw3DOutLine();

    m_ShowMouse;
    ViewMgr::CSendMsg( this, REDRAW );
}


BYTE _pascal_ Button::CAction( const Message* msg, BYTE chkBtn )
{
    BBOOL isdown;
    static BYTE pending = 0;
	BYTE mb = msg->mouButton, action;
    Button* btn = (Button*)msg->ToObj;

    switch ( msg->actId ) {
        case CANCEL_CLICK:
            beep( 10000, 5 );
            btn->CRestoreOutLine();
            pending = mb = action = 0;
            m_ShowMouse;
            return 0;
        case 0:
            break;
        case MOUSE_OFF:
            if ( pending != HOLD ) return 0;
            break;
        default:
            return 0;
    }
    if ( chkBtn && ( mb & BUTTON ) != chkBtn ) {
        if ( pending == HOLD ) {
            m_HideMouse;
#ifdef OUTLINE_3D
            btn->CDraw3DOutLine( FALSE, TRUE );
#else
            btn->CDraw3DOutLine();
#endif
            m_ShowMouse;
            pending = 0;
        }
        return 0;
    }

	action = CLICK;
	isdown = FALSE;

	if (mb & HOLD) {
		isdown = TRUE;
        action = HOLD;
	} else if ( !mb )
		action = 1;

	if (pending != action) {
        if ( !btn->CHighLiteOutLine() )
            m_HideMouse;
#ifdef OUTLINE_3D
        if ( isdown )
            btn->CDraw3DOutLine(TRUE);
        btn->CDraw3DOutLine(isdown, TRUE);
#else
        btn->CDraw3DOutLine(isdown);
#endif
        m_ShowMouse;
		pending = action;
        return pending;
    }
    return action;
}
