#ifdef MOU_INTERFACE

#include "vgl.h"

#define LEFT_PRESSED   1
#define RIGHT_PRESSED  2
#define LNR_PRESSED    3
#define MIDDLE_PRESSED 4
#define LNM_PRESSED    5
#define RNM_PRESSED    6
#define ALL_PRESSED    7


//
// Mouse Functions expected to use in ObjMgr
//
#define m_MouseInit                     vglInitMouse()
#define m_MouseDeInit


// Redraw the mouse cursor and read x & y corrdinates
#define m_UpdateMouse

int __mouseX( void );
int __mouseY( void );
int __mouseButton( void );

#define m_MouseX                        __mouseX()
#define m_MouseY                        __mouseY()
#define m_ShowMouse                     vglShowMouse()
#define m_HideMouse                     vglHideMouse()
#define m_MouseButtonStatus             __mouseButton()
//#define m_FreezeMouse                   MouseFrozen = 1
//#define m_DeFreezeMouse                 MouseFrozen = 0

//
// Other functions not expected to use
//
// Set the cursor to cur <char _FAR_ *> in color <int>
//
#define m_MouseSetCur(cur, color )       x_define_mouse_cursor(cur, color )
#define m_MouseSetXY(x, y )              x_position_mouse(x, y )

// Set a rect the pointer is limited in
//
#define m_MouseWindow(x1, y1, x2, y2 )      x_mouse_window(x1, y1, x2, y2 )

// Set the mouse cursor's color
//
#define m_MouseCurColor(color )          MouseColor = color;

#define CLICK  128 // 10000000
#define HOLD   16  // 00010000
#define DOUBLE 8   // 00001000
#define BUTTON 7   // 00000111

#define LCLICK (CLICK|LEFT_PRESSED)
#define MCLICK (CLICK|MIDDLE_PRESSED)
#define RCLICK (CLICK|RIGHT_PRESSED)
#define LHOLD  (HOLD|LEFT_PRESSED)
#define MHOLD  (HOLD|MIDDLE_PRESSED)
#define RHOLD  (HOLD|RIGHT_PRESSED)

#endif
