#include "strbox.h"
#include "macros.h"
#include "viewmgr.h"
#include "keys.h"
#include "vidinter.h"
#include "stredit.h"

#ifdef __MSDOS__
#include <dos.h>
#endif

// Global Variable ( The text blinking caret )
Caret gTextCaret;
// End of Global Variable

int Caret       ::x             = 0;
int Caret       ::y             = 0;
int Caret       ::y2            = 0;
unsigned Caret  ::Delay         = 2;
Timer Caret     ::blink;
BBOOL Caret     ::on            = FALSE;
BBOOL Caret     ::draw          = FALSE;

void _pascal_ Caret::CDraw( void )
{
    draw = FALSE;
    if( gStrEditor.CIsInsert() )
        v_PutLine( x, y, x, y2, HighLiteColor );
    else
        v_PutLine( x, y2+1, x+4, y2+1, HighLiteColor );
}


void _pascal_ Caret::CErase( void )
{
    static BBOOL i = gStrEditor.CIsInsert();
    draw = TRUE;
    if ( i )
        v_PutLine( x, y, x, y2, FaceColor );
    else
        v_PutLine( x, y2+1, x+4, y2+1, FaceColor );
    i = gStrEditor.CIsInsert();

}


DeclareIntCClassNoPtr( Caret, ShowCaret )
{
    if ( blink.peekTime() >= Delay ) {

        if ( draw )
                    CDraw();

        else
                    CErase();

        blink.start();
	}

	return 0;
}

void _pascal_ Caret::CShow( void )
{
	if ( !on ) {

		CDraw();
		on = TRUE;

		blink.start();

		CurrentMgr->CRegInt( ShowCaret );

	}
}

void _pascal_ Caret::CHide( void )
{
	if ( on ) {

		CErase();
		on = FALSE;

		CurrentMgr->CUnRegInt( ShowCaret, FALSE );

	}
}

int StrBox  ::  PixelLen;
char *StrBox::  fptr;
int StrBox  ::  fptrAt;
int StrBox  ::  fi;
int StrBox  ::  textX1;

int _pascal_ StrBox::CRestoreOutLine( void )
{
    if ( Button::CRestoreOutLine() ) {
        CDrawOutLine();
        return OutLineColor;
    }

    return 0;
}

void _pascal_ StrBox::CShowObject( void )
{
    CHighLiteOutLine();
    CRestoreOutLine();

    CDrawFace();
    CDrawOutLine();

    m_ShowMouse;
    ViewMgr::CSendMsg( this, REDRAW );
}


int _pascal_ StrBox::CShowName( void )
{
    char *t = zsBname;
    if ( !t ) t = StrPtr;
    if ( t )
        return v_LimitPixelPrint( x1() + 2, CCenterMsgY(), TextColor,
                                FaceColor, x2() - x1() - 3, t );
    else
        return sX1+3;
}

void _pascal_ StrBox :: InitEdit( char *str )
{
    m_HideMouse;

    textX1      = x1() + 2;
    PixelLen    = x2() - textX1 - 2;

    str[0]      = 0;

    if ( StrPtr != zsBname ) {
        delete StrPtr;
        StrPtr = 0;
        if ( zsBname ) {
            StrPtr = new char[strlen(zsBname)+1];
            strcpy( StrPtr, zsBname );
        }
    }

    if ( StrPtr ) {

        strcpy( str, StrPtr );

        fi      = strlen( str );
        fptr    = v_StrToFitPixels( str, str + fi - 1, PixelLen, fptrAt );
        gTextCaret.CSetX( v_StrPixelLenUpTo (  fptr,
                            fi - fptrAt, PixelLen ) + textX1 );
        delete StrPtr;
        StrPtr = 0;
    }
    else
    {
        fi      = fptrAt = 0;
        fptr    = str;

        gTextCaret.CSetX( textX1 );
	}

    zsBname = str;
    gStrEditor.CSetMaxLen( 256 );
	gStrEditor.CSetStr( str, fi );

	CHighLiteOutLine();

	gTextCaret.CSetY( CCenterMsgY() );
    v_LimitPixelPrint( textX1, CCenterMsgY ( ), TextColor,
                        FaceColor, PixelLen, fptr );
    gTextCaret.CShow ( );

    m_ShowMouse;

//    ViewMgr::CSetObjectFocus( TRUE );
//    ViewMgr::TraceMouse                 = FALSE;
}

DeclareObjHClass( StrBox, CStrBoxHand )
{
    static char *str = 0;   // memory use when editing string
    static BBOOL receiving; // true if entering string

    static StrBox *myPtr;

    myPtr   =   (StrBox*)msg->ToObj;

    if ( msg->actId == REDRAW ) {
        myPtr->CHighLiteOutLine();
        myPtr->CRestoreOutLine();

        myPtr->CDrawFace();
        myPtr->CDrawOutLine();

        m_ShowMouse;
    } else if ( !receiving ) {
        if ( msg->actId == MOUSE_ON || msg->mouButton == LCLICK )
        {
            receiving       = TRUE;
            if ( !str )
                str = new char[256];
            if ( !str )
                perror("Mem pool new");
            myPtr->InitEdit( str );
        }

    } else

        switch( msg->actId )
        {
        case MOUSE_OFF:
        case CANCEL_CLICK:
            gTextCaret.CHide();
            if ( receiving ) { // Make sure no second entrance
                receiving       = FALSE;

                if ( gStrEditor.CLen() )
                {
                    myPtr->StrPtr = new char[gStrEditor.CLen()+1];
                    if( !myPtr->StrPtr )
                        perror("new in strbox");
                    else
                        strcpy( myPtr->StrPtr, str );
                } else
                    myPtr->StrPtr = 0;

                myPtr->zsBname = myPtr->StrPtr;

                ViewMgr::CSetObjectFocus( FALSE );
    #ifdef TRACE_MOUSE
                ViewMgr::TraceMouse = TRUE;
    #endif
                myPtr->CShowObject();  // will restore outline also

            }
            return 0;

        case KEY_DOWN:

            int result = gStrEditor.CEdit(msg->keyDown);

            //
            //  Update string on screen accordingly
            //

            if ( result == ENTER ) {    // Enter pressed, done editing

                // modify message and send it to self again

                msg->actId      = CANCEL_CLICK;
                CStrBoxHand ( msg );
                msg->actId      = KEY_DOWN;

            } else if ( gStrEditor.CIsUpdate() ) {

                BBOOL refreshMsg = TRUE;

                fi = gStrEditor.CPos();

                // frame at begin segment of the string

                if ( fi == 0 ) {    // HOME

                    fptr = str;
                    fptrAt = 0;


                // frame at last segment of the string

                } else if ( fi == gStrEditor.CLen() ) {  // END

                    beep( 200, 1 );

                    fptr = v_StrToFitPixels( str, str + fi -1 ,
                                             PixelLen, fptrAt );

// Debug (put a red message on the screen)
//                    v_ShowMsgLen( 0, 100, PixelLen, cGREEN, cRED, fptr );


                // frame move left

                } else if ( fi < fptrAt || msg->keyDown == BACKSPACE ) {

                    if ( fptr > str ) {

                        fptr    --;
                        fptrAt  --;

                    }


                // frame move right
                // ( framePixelLen and PixelLen must < v_Width )

                } else if ( v_StrPixelLenUpTo( fptr,
                            fi - fptrAt, v_Width ) > PixelLen ) {

                    do {  // keep looping until enough pixel is freed up in the
                          // frame so the character to the right can fit in

                        fptr    ++;
                        fptrAt  ++;

                    } while ( v_StrPixelLenUpTo( fptr,
                                        fi - fptrAt, v_Width ) > PixelLen );

                } else if ( result ) {  // key didn't affect string content

                    refreshMsg = FALSE;

                }

                if ( myPtr->CMouseOnMe() )
                                    m_HideMouse;

                gTextCaret.CErase();
                gTextCaret.CSetX( v_StrPixelLenUpTo( fptr,
                                    fi - fptrAt, PixelLen ) + textX1 );

                if ( refreshMsg )

                    v_LimitPixelPrint( textX1, myPtr->CCenterMsgY ( ),
                                       TextColor, FaceColor, PixelLen, fptr );

                gTextCaret.CDraw();

                m_ShowMouse;

            } else
                if ( result < 0 )
                            beep( 300, 10 );
            break;
        default:
            break;
        }

    if( ((StrBox*)msg->ToObj)->PrvHandler)
        ((StrBox*)msg->ToObj)->PrvHandler( msg );
	return 0;
}
